<template>
  <a-modal
    :title="modalTitle"
    :width="1000"
    :visible="visible"
    :confirmLoading="confirmLoading"
    class="ant-modal2"
    :footer="false"
    @cancel="handleCancel"
  >
    <a-card :bordered="false">
      <div class="table-page-search-wrapper">
        <a-form layout="inline">
          <a-row :gutter="48">
            <a-col :md="8" :sm="24">
              <a-form-item label="关键字">
                <a-input v-model="queryParam.keyword" placeholder="请输入名称/类型名称"/>
              </a-form-item>
            </a-col>
            <a-col :md="8 || 24" :sm="24">
              <span class="table-page-search-submitButtons">
                <a-button type="primary" @click="$refs.table.refresh(true)">查询</a-button>
                <a-button style="margin-left: 8px" @click="resetSearchForm">重置</a-button>
              </span>
            </a-col>
          </a-row>
        </a-form>
      </div>

      <div class="table-operator">
        <a-button v-if="$auth('fill-gathers-edit')" type="primary" icon="plus" @click="addFillInfos">新增</a-button>
      </div>

      <s-table
        ref="table"
        size="default"
        rowKey="id"
        :columns="columns"
        :data="loadData"
        :alert="options.alert"
        :customRow="options.customRow"
        :rowSelection="options.rowSelection"
        showPagination="auto"
      >
        <span slot="action" slot-scope="record">
          <template>
            <a @click="handleView(record)">查看</a>
            <operation-button
              v-if="$auth('fill-gathers-edit')"
              :type="2"
              title="是否要删除该条数据？"
              @confirm="batchDelete(record.id)">删除</operation-button>
          </template>
        </span>
      </s-table>
      <detail ref="detailModal"/>
      <fill-info-select-modal :type="'checkbox'" ref="fillInfoSelectModal" @selected="selectInfoSave" />
    </a-card>
    <template slot="footer">
      <a-button :loading="confirmLoading" type="primary" @click="handleCancel()">取消</a-button>
      <a-button :loading="confirmLoading" type="primary" @click="handleSelect()">确定</a-button>
    </template>
  </a-modal>
</template>

<script>
import { STable, Ellipsis } from '@/components'
import Detail from './Detail'
import FillInfoSelectModal from '@/views/fill/info/modules/FillInfoSelectModal'
import {
  getFillGatherInfoPage,
  fetchFillGatherInfo,
  addFillGatherInfos,
  deleteFillGatherInfos
} from '@/api/fill/gather-info'

export default {
  name: 'FillGatherInfoSelectModal',
  components: {
    STable,
    Ellipsis,
    FillInfoSelectModal,
    Detail
  },
  props: {
    type: {
      type: String,
      default: 'radio'
    }
  },
  data () {
    return {
      confirmLoading: false,
      mdl: {},
      modalTitle: null,
      visible: false,
      extraModel: {},
      // 查询参数
      queryParam: {
      },
      extraQueryParam: {
      },
      natureMap: {},
      typeMap: {},
      useTypeMap: {},
      // 表头
      columns: [
        {
          title: '序号',
          dataIndex: 'index',
          customRender: (text, record, index) => {
            return `${(this.$refs.table.localPagination.current - 1) * this.$refs.table.localPagination.pageSize + index + 1}`
          }
        },
        {
          title: '名称',
          dataIndex: 'infoName'
        },
        {
          title: '字段名称',
          dataIndex: 'fieldKey'
        },
        {
          title: '类型',
          dataIndex: 'type',
          customRender: (text, record, index) => {
            return this.BaseTool.Table.getMapText(this.typeMap, text)
          }
        },
        {
          title: '性质',
          dataIndex: 'nature',
          customRender: (text, record, index) => {
            return this.BaseTool.Table.getMapText(this.natureMap, text)
          }
        },
        {
          title: '操作',
          key: 'action',
          width: '200px',
          align: 'center',
          scopedSlots: { customRender: 'action' }
        }
      ],
      // 下拉框map
      // 加载数据方法 必须为 Promise 对象
      loadData: parameter => {
        parameter = {
          ...parameter,
          ...this.queryParam,
          ...this.extraQueryParam,
          dataScope: {
            sortBy: 'desc',
            sortName: 'update_time'
          }
        }
        return getFillGatherInfoPage(parameter)
          .then(res => {
            return res.data
          })
      },
      selectedRowKeys: [],
      selectedRows: [],

      options: {
        alert: { show: true, clear: () => { this.selectedRowKeys = [] } },
        rowSelection: {
          selectedRowKeys: this.selectedRowKeys,
          onChange: this.onSelectChange
        }
      },
      optionAlertShow: false,
      isCreated: false
    }
  },
  created () {
    // 下拉框map
    this.typeMap = this.DictCache.getLabelByValueMapByType(this.DictCache.TYPE.FILL_INFO_TYPE)
    this.natureMap = this.DictCache.getLabelByValueMapByType(this.DictCache.TYPE.FILL_INFO_NATURE)
  },
  methods: {
    tableOption () {
      if (!this.optionAlertShow) {
        this.options = {
          alert: { show: true, clear: () => { this.selectedRowKeys = [] } },
          rowSelection: {
            selectedRowKeys: this.selectedRowKeys,
            onChange: this.onSelectChange,
            type: this.type,
            getCheckboxProps: record => ({
              props: {
                disabled: false,
                name: record.id
              }
            })
          },
          customRow: (record) => {
            return {
              on: { // 事件
                click: (event) => { // 点击行
                  // 选择对象
                  this.mySelect([record.id], [record])
                },
                dblclick: (event) => {
                  this.mySelect([record.id], [record])
                  this.handleSelect()
                }
              }
            }
          }
        }
        this.optionAlertShow = true
      } else {
        this.options = {
          alert: false,
          rowSelection: null
        }
        this.optionAlertShow = false
      }
    },
    addFillInfos () {
      this.$refs.fillInfoSelectModal.base({ hideSelectGatherId: this.extraQueryParam.gatherId })
    },
    handleView (record) {
      fetchFillGatherInfo({ id: record.id }).then(res => {
        const modal = this.$refs.detailModal
        modal.base(res.data)
      })
    },
    handleOk () {
      this.$refs.table.refresh()
    },
    onSelectChange (selectedRowKeys, selectedRows) {
      this.selectedRowKeys = selectedRowKeys
      this.selectedRows = selectedRows
    },
    resetSearchForm () {
      this.queryParam = {
      }
      this.$refs.table.refresh(true)
    },
    base (extraModel, queryParam = {}) {
      this.visible = true
      this.modalTitle = '配置列表'
      this.extraQueryParam = queryParam
      this.extraModel = extraModel
      if (this.isCreated) {
        this.$refs.table.clearSelected()
        this.options.rowSelection.type = this.type
        this.handleOk()
      } else {
        this.tableOption()
        this.isCreated = true
      }
    },
    batchDelete (id) {
      let ids = []
      if (this.BaseTool.String.isBlank(id)) {
        const length = this.selectedRows.length
        if (length === 0) {
          this.$message.info('请选择要删除的记录')
          return
        }
        ids = this.selectedRows.map(item => item.id)
      } else {
        ids = [id]
      }
      deleteFillGatherInfos(ids).then(res => {
        this.$message.info('删除成功')
        this.handleOk()
        this.$refs.table.clearSelected()
      })
    },
    handleCancel () {
      this.visible = false
      this.confirmLoading = false
    },
    handleSelect () {
      if (this.selectedRowKeys.length === 0) {
        this.$message.warn('请至少选择一项信息')
      } else {
        this.confirmLoading = true
        this.$emit('selected', this.extraModel, this.selectedRowKeys, this.selectedRows)
        this.confirmLoading = false
        this.visible = false
      }
    },
    mySelect (selectedRowKeys, selectedRows) {
      if (this.type === 'radio') {
        this.$refs.table.updateSelect(selectedRowKeys, selectedRows)
        this.$refs.table.rowSelection.onChange(selectedRowKeys, selectedRows)
      } else {
        let mySelectedRowKeys
        let mySelectedRows = this.selectedRows.filter(item => item.id !== selectedRowKeys[0])
        if (this.selectedRowKeys.includes(selectedRowKeys[0])) {
          mySelectedRowKeys = this.selectedRowKeys.filter(item => item !== selectedRowKeys[0])
        } else {
          mySelectedRowKeys = [...selectedRowKeys, ...this.selectedRowKeys]
          mySelectedRows = [...mySelectedRows, ...selectedRows]
        }
        this.$refs.table.updateSelect(mySelectedRowKeys, mySelectedRows)
        this.$refs.table.rowSelection.onChange(mySelectedRowKeys, mySelectedRows)
      }
    },
    selectInfoSave (extraModel, selectedRowKeys, selectedRows) {
      console.log(111, extraModel, selectedRowKeys, selectedRows)
      const gatherId = this.extraQueryParam.gatherId
      addFillGatherInfos({ gatherId: gatherId, infoIds: selectedRowKeys })
        .then(() => {
          this.$refs.table.refresh(true)
        }).catch(() => {
        })
    }
  }
}
</script>
